module dds_ctrl(
    clk          ,
    rst_n        ,
    cfg_en       ,
    cfg_time     ,
    cfg_repeat0  ,
    cfg_repeat1  ,
    cfg_repeat2  ,
    cfg_add0     ,
    cfg_add1     ,
    cfg_add2     ,
    dout       
);

input             clk           ;
input             rst_n         ;
input             cfg_en        ;
input  [15:0]     cfg_time      ;
input  [15:0]     cfg_repeat0   ;
input  [15:0]     cfg_repeat1   ;
input  [15:0]     cfg_repeat2   ;
input  [15:0]     cfg_add0      ;
input  [15:0]     cfg_add1      ;
input  [15:0]     cfg_add2      ;
output [15:0]     dout          ;
reg    [15:0]     dout          ;

reg    [15:0]     cnt0          ;
wire              add_cnt0      ;
wire              end_cnt0      ;
reg    [15:0]     cnt1          ;
reg    [15:0]     x             ;
reg    [15:0]     y             ;
wire              add_cnt1      ;
wire              end_cnt1      ;
reg [ 7:0]        cnt2          ;
wire              add_cnt2      ;
wire              end_cnt2      ;

always @(posedge clk or negedge rst_n)begin
    if(!rst_n)begin
        cnt0 <= 0;
    end
    else if(add_cnt0)begin
        if(end_cnt0)
            cnt0 <= 0;
        else
            cnt0 <= cnt0 + 1;
    end
end

assign add_cnt0 = cfg_en;
assign end_cnt0 = add_cnt0 && cnt0==cfg_time-1 ;


always @(posedge clk or negedge rst_n)begin 
    if(!rst_n)begin
        cnt1 <= 0;
    end
    else if(add_cnt1)begin
        if(end_cnt1)
            cnt1 <= 0;
        else
            cnt1 <= cnt1 + 1;
    end
end

assign add_cnt1 = end_cnt0;
assign end_cnt1 = add_cnt1 && cnt1==x-1 ; 


always @(posedge clk or negedge rst_n) begin 
    if (rst_n==0) begin
        cnt2 <= 0; 
    end
    else if(add_cnt2) begin
        if(end_cnt2)
            cnt2 <= 0; 
        else
            cnt2 <= cnt2+1 ;
   end
end
assign add_cnt2 = end_cnt1;
assign end_cnt2 = add_cnt2  && cnt2 ==3-1  ;

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        dout <= 0;
    end
    else if(cfg_en) begin
        dout <= y ;
    end
    else begin
        dout <= 0;
    end
end


always  @(*)begin
    if(cnt2==0) begin
        x = cfg_repeat0;
        y = cfg_add0   ;
    end
    else if(cnt2==1)begin
        x = cfg_repeat1;
        y = cfg_add1   ;
    end
    else begin
        x = cfg_repeat2;
        y = cfg_add2   ;
    end
end



endmodule




