module mdyAd9709If(
           clk       ,
           rst_n     ,
           din       ,
           din_vld   ,
           din_rdy   ,
           dac_mode  ,
           dac_clka  ,
           dac_da    ,
           dac_wra   ,
           dac_sleep  
           );
input             clk       ;
input             rst_n     ;
input  [   7:0]   din       ;
input             din_vld   ;
output            din_rdy   ;
output            dac_mode  ;
output            dac_clka  ;
output [ 8-1:0]   dac_da    ;
output            dac_wra   ;
output            dac_sleep ;

reg               din_rdy   ;
reg    [3:0]      cnt0      ;
wire              add_cnt0  ;    
wire              end_cnt0  ;
reg    [7:0]      cnt1      ;
wire              add_cnt1  ;
wire              end_cnt1  ;
reg    [2:0]      cnt2      ;
wire              add_cnt2  ;
wire              end_cnt2  ;
reg    [2:0]      cnt3      ;
wire              add_cnt3  ;
wire              end_cnt3  ; 
reg    [3:0]      x         ;
reg    [7:0]      y         ;

reg    [6:0]      addr      ;
reg    [7:0]      sin_data  ;

reg    [7:0]      dac_da    ;
wire              dac_sleep  ;
wire              dac_wra   ;
reg               dac_clka   ;
reg               dac_clka_ff0   ;
wire              dac_mode ;
reg               flag_add_tmp ;
reg               flag_add     ;

always  @(*)begin
    if(din_vld)begin
        flag_add_tmp = 1;
    end
    else if(end_cnt0) begin
        flag_add_tmp = 0;
    end
    else begin
        flag_add_tmp = flag_add;
    end
end



always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        flag_add <= 0;
    end
    else begin
        flag_add <= flag_add_tmp;
    end
end




always @(posedge clk or negedge rst_n)begin
    if(!rst_n)begin
        cnt0 <= 0;
    end
    else if(add_cnt0)begin
        if(end_cnt0)
            cnt0 <= 0;
        else
            cnt0 <= cnt0 + 1;
    end
end

assign add_cnt0 = flag_add ;
assign end_cnt0 = add_cnt0 && cnt0== 2-1;


always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        dac_da <= 0;
    end
    else if(din_vld)begin
        dac_da <= din;
    end
end

always  @(posedge clk or negedge rst_n)begin
	if(rst_n==1'b0)begin
        dac_clka <= 0;
    end
    else if(add_cnt0 && cnt0==1-1)begin
		  dac_clka  <= 1;
    end
    else if(end_cnt0)begin
		  dac_clka  <= 0;
    end
end

always  @(*)begin
    if(flag_add_tmp)
        din_rdy = 0;
    else
        din_rdy = 1;
end



assign dac_sleep = 0        ;
assign dac_wra   = dac_clka ;
assign dac_mode = 1         ;




endmodule

