module mdyCfgCtrl(
    clk         ,
    rst_n       ,
    `include "mdyCfg_intf.v"
    din         ,
    din_vld     ,
    dout        ,
    dout_vld

);

parameter        D_W = 64    ;

input            clk         ;
input            rst_n       ;
input  [D_W-1:0] din         ;
input            din_vld     ;


output [D_W-1:0] dout        ;
output           dout_vld    ;
reg    [D_W-1:0] dout        ;
reg              dout_vld    ;

wire   [31:0]    flag_get_data ;
wire   [14:0]    flag_get_addr ;
wire             reg_wr        ;
wire             reg_rd        ;
`include "mdyCfg_io.v"


`include "mdyCfg_always.v"
assign reg_wr        = din[47]==0 && din_vld   ;
assign reg_rd        = din[47]==1 && din_vld   ;
assign flag_get_addr = din[46:32];
assign flag_get_data = din[31: 0];



always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        dout      <= 0;
        dout_vld  <= 0;
    end
    else begin
        dout     <= {din[63:32],rdata};
        dout_vld <= reg_rd        ;
    end
end



endmodule
