reg  [31:0]     rdata    ; 
wire  [31:0]               CTRL0                           ; 
reg                       CTRL0_mode                      ; 
reg                       CTRL0_en                        ; 
wire  [31:0]               TIME                            ; 
reg   [ 15: 0]            TIME_data                       ; 
wire  [31:0]               REPEAT0                         ; 
reg   [ 15: 0]            REPEAT0_d1                      ; 
reg   [ 15: 0]            REPEAT0_d0                      ; 
wire  [31:0]               REPEAT1                         ; 
reg   [ 15: 0]            REPEAT1_d2                      ; 
wire  [31:0]               ADD0                            ; 
reg   [ 15: 0]            ADD0_d1                         ; 
reg   [ 15: 0]            ADD0_d0                         ; 
wire  [31:0]               ADD1                            ; 
reg   [ 15: 0]            ADD1_d2                         ; 

always  @(posedge clk or negedge rst_n)begin 
    if(rst_n==1'b0)begin 
        CTRL0_mode <= 0 ; 
    end 
    else if(reg_wr && flag_get_addr==16'h0000 )begin 
        CTRL0_mode <= flag_get_data[1]; 
    end 
end 

always  @(posedge clk or negedge rst_n)begin 
    if(rst_n==1'b0)begin 
        CTRL0_en <= 0 ; 
    end 
    else if(reg_wr && flag_get_addr==16'h0000 )begin 
        CTRL0_en <= flag_get_data[0]; 
    end 
end 

always  @(posedge clk or negedge rst_n)begin 
    if(rst_n==1'b0)begin 
        TIME_data <= 50000 ; 
    end 
    else if(reg_wr && flag_get_addr==16'h0001 )begin 
        TIME_data <= flag_get_data[15:0]; 
    end 
end 

always  @(posedge clk or negedge rst_n)begin 
    if(rst_n==1'b0)begin 
        REPEAT0_d1 <= 2 ; 
    end 
    else if(reg_wr && flag_get_addr==16'h0002 )begin 
        REPEAT0_d1 <= flag_get_data[31:16]; 
    end 
end 

always  @(posedge clk or negedge rst_n)begin 
    if(rst_n==1'b0)begin 
        REPEAT0_d0 <= 2 ; 
    end 
    else if(reg_wr && flag_get_addr==16'h0002 )begin 
        REPEAT0_d0 <= flag_get_data[15:0]; 
    end 
end 

always  @(posedge clk or negedge rst_n)begin 
    if(rst_n==1'b0)begin 
        REPEAT1_d2 <= 2 ; 
    end 
    else if(reg_wr && flag_get_addr==16'h0003 )begin 
        REPEAT1_d2 <= flag_get_data[15:0]; 
    end 
end 

always  @(posedge clk or negedge rst_n)begin 
    if(rst_n==1'b0)begin 
        ADD0_d1 <= 128 ; 
    end 
    else if(reg_wr && flag_get_addr==16'h0004 )begin 
        ADD0_d1 <= flag_get_data[31:16]; 
    end 
end 

always  @(posedge clk or negedge rst_n)begin 
    if(rst_n==1'b0)begin 
        ADD0_d0 <= 128 ; 
    end 
    else if(reg_wr && flag_get_addr==16'h0004 )begin 
        ADD0_d0 <= flag_get_data[15:0]; 
    end 
end 

always  @(posedge clk or negedge rst_n)begin 
    if(rst_n==1'b0)begin 
        ADD1_d2 <= 128 ; 
    end 
    else if(reg_wr && flag_get_addr==16'h0005 )begin 
        ADD1_d2 <= flag_get_data[15:0]; 
    end 
end 

assign     CTRL0 =  { 30'b0, CTRL0_mode, CTRL0_en } ;
assign     TIME =  { 16'b0, TIME_data } ;
assign     REPEAT0 =  { REPEAT0_d1, REPEAT0_d0 } ;
assign     REPEAT1 =  { 16'b0, REPEAT1_d2 } ;
assign     ADD0 =  { ADD0_d1, ADD0_d0 } ;
assign     ADD1 =  { 16'b0, ADD1_d2 } ;
always  @(*)begin 
    case(flag_get_addr) 
        16'h0000: rdata = CTRL0                            ; 
        16'h0001: rdata = TIME                             ; 
        16'h0002: rdata = REPEAT0                          ; 
        16'h0003: rdata = REPEAT1                          ; 
        16'h0004: rdata = ADD0                             ; 
        16'h0005: rdata = ADD1                             ; 
        default  : rdata = 0; 
    endcase 
end 
