module uart_cfg_s2p(
       clk      ,
       rst_n    ,
       cfg_head ,
       din      ,
       din_vld  ,
       dout     ,
       dout_vld  
);


input                 clk            ;		
input                 rst_n          ;	
input [ 15:0]         cfg_head       ;
input [  7:0]         din            ;
input                 din_vld        ;
output[ 63:0]         dout           ;		
output                dout_vld       ;
wire                  flag_head_start;
reg                   flag_head      ;
reg [ 7:0]            din_ff         ;
reg [ 3:0]            cnt0           ;
wire                  add_cnt0       ;
wire                  end_cnt0       ;
reg   [ 63:0]         dout           ;		
reg                   dout_vld       ;
reg                   dout_sop       ;
reg                   dout_eop       ;

assign flag_head_start = flag_head==0 && (din_ff==cfg_head[15:8] && din==cfg_head[7:0]) && din_vld ; 
always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        flag_head <= 0;
    end
    else if(flag_head_start)begin
        flag_head <= 1;
    end
    else if(end_cnt0)begin
        flag_head <= 0;
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        din_ff <= 0;
    end
    else if(flag_head==0 && din_vld) begin
        din_ff <= din ;
    end
    else if(flag_head)begin
        din_ff <= 0 ;
    end
end




always @(posedge clk or negedge rst_n) begin 
    if (rst_n==0) begin
        cnt0 <= 0; 
    end
    else if(add_cnt0) begin
        if(end_cnt0)
            cnt0 <= 0; 
        else
            cnt0 <= cnt0+1 ;
   end
end
assign add_cnt0 = flag_head && din_vld;
assign end_cnt0 = add_cnt0  && cnt0 == 6-1 ;

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        dout <= 0;
    end
    else if(add_cnt0) begin
        dout[63:48]          <= cfg_head ;
        dout[47-cnt0*8 -:8 ] <= din      ;
    end
end

always  @(posedge clk or negedge rst_n)begin
    if(rst_n==1'b0)begin
        dout_vld <= 0;
    end
    else begin
        dout_vld <= end_cnt0 ;
    end
end



endmodule

